import sys
import importlib
import os
import taskpanel

import pathlib

global basefolder
basefolder=pathlib.Path(taskpanel.__file__).parent
print('Basefolder: ',basefolder)

class weldslicerWorkbench (Workbench):

	MenuText = "weldslicer"
	ToolTip = "Workbench for slicing multilayer welds"
	Icon = os.path.join(basefolder,"Resources","ws.svg")


	def Initialize(self):
		"""This function is executed when FreeCAD starts"""
		#sys.path.append('/home/jb/pgr3/weldslicerWB')
		#import importlib
		#importlib.reload(taskpanel)
		self.list = ['Face Panel','Wire Task Panel','Point Task Panel','Wps Task Panel','Connected Faces Task Panel','Weld Cover Faces Task Panel','Show Paths Task Panel','Simulate Paths Task Panel']  # A list of command names created in the line above
		self.appendToolbar("My Commands",self.list) # creates a new toolbar with your commands
		#self.appendMenu("My New Menu",self.list) # creates a new menu
		#self.appendMenu(["An existing Menu","My submenu"],self.list) # appends a submenu to an existing menu

	def Activated(self):
		"""This function is executed when the workbench is activated"""
		return

	def Deactivated(self):
		"""This function is executed when the workbench is deactivated"""
		return

	def ContextMenu(self, recipient):
		"""This is executed whenever the user right-clicks on screen"""
		# "recipient" will be either "view" or "tree"
		self.appendContextMenu("My commands",self.list) # add commands to the context menu

	def GetClassName(self): 
		# This function is mandatory if this is a full Python workbench
		# This is not a template, the returned string should be exactly "Gui::PythonWorkbench"
		return "Gui::PythonWorkbench"
	   
Gui.addWorkbench(weldslicerWorkbench())