# -*- coding: utf-8 -*

#-------------------------------------------------------------------------------
# Name:        module1
# Purpose:
#
# Author:      Johannes Bichler 
#
# Created:     08.08.2021
# Copyright:   (c) Johannes Bichler 2021
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import os
import fnmatch
import re


#############################################################
#############################################################

def filesearch(directory,match,start,end):
	ids=[]
	files=[]
	for filename in os.listdir(directory):
		if fnmatch.fnmatch(filename, match):
			ids.append(int(filename[start:end]))
			files.append(filename)
			#print(filename)
	return files,ids


#############################################################
#############################################################


def filesearch2(directory,match,start,end):
	files=[]
	for filename in os.listdir(directory):
		if fnmatch.fnmatch(filename, match):
			files.append(filename)
			print(filename)
	return files


#############################################################
#############################################################

def extractnumbers(files):
	regex = r'\d+'	#find numbers
	group=[]
	for j,ff in enumerate(files):
		match = re.findall(regex, ff)
		match=[int(m) for m in match]
		for i,m in enumerate(match):
			if (len(group)-1)<i:
				group.append([])
			group[i].append(m)
	return group

#############################################################
#############################################################

def generalGroup(data,num_processes):
	'''
	generalGroup(data,num_processes)
	return list of length num_processes with indexes
	split data into approx. equal chunks
	return the grouped indexes into data
	for multiprocessing load leveling
	'''

	#assign data lists:
	takes=[[] for i in range(num_processes)]
	i=0
	safeloop=0
	while i<=len(data):
		safeloop=safeloop+1
		if safeloop>10000:
			break
		for t in takes:
			if i>=len(data):
				break
			else:
				t.append(i)
			i=i+1
	return takes

#############################################################
#############################################################

def groupFiles(dirname,filename,num_chunks):
	'''
	get the data into sorted chunks by there ptnb
	return files_chunk,index_chunks,all_files,all_index
	'''
	directory=dirname
	match=filename[:-4]+'*'
	start=len(filename[:-4])
	end=-4
	wdfiles,wdindex=filesearch(directory,match,start,end) #only filenames
	wdindex_sort=wdindex[:]
	wdindex_sort.sort()
	wdfiles=[wdfiles[wdindex.index(ptid)] for ptid in wdindex_sort]
	wdindex=wdindex_sort[:]

	takes=generalGroup(wdfiles,num_chunks)
	wdfiles_chunks=[[wdfiles[i] for i in t] for t in takes]
	wdindex_chunks=[[wdindex[i] for i in t] for t in takes]

	return wdfiles_chunks,wdindex_chunks,wdfiles,wdindex

#############################################################
#############################################################
