# -*- coding: utf-8 -*

#-------------------------------------------------------------------------------
# Name:        module1
# Purpose:     creates the points and vecs from base model for slicing
#
# Author:      Johannes Bichler 
#
# Created:     08.08.2021
# Copyright:   (c) Johannes Bichler 2021
# Licence:     <your licence>
#-------------------------------------------------------------------------------

'''
from __future__ import print_function
from future import standard_library
standard_library.install_aliases()
from builtins import str
from builtins import object
'''
import sys

#sys.path.append('/home/jb/miniconda3/envs/py369/lib/python3.6/site-packages')
from FreeCAD import Console,Base
import Part
import math
import os
import numpy as np
import csv
import io
import yaml

import wc

def get_circumference_weave(start_vertex,base_wire,poi_vector):
	'''
	wire must nut have Placment other than (0,0,0) and Rotation (0,0,0)
	start_vertex,wire,poi_vector
	return the circumference from start_vertex until poi_vector
	only for open wires which have all forward oriented edges
	'''
	poi=poi_vector
	circumference=0.0
	tol=1e-6 #was 1e-6
	param_tol=1e-9 #was 1e-8
	approx_solution=False
	back=wc.check_point_on_edge_weave(base_wire,poi)
	if back[0] is False:
		Console.PrintMessage("+++++++++++++++++++++++++++++++++++++++"+'\n')
		#break
	Console.PrintMessage("get circumference back:  " + str(back)+'\n')
	index=back[1]
	target_param=back[2]
	print('check point on edge: ',back)
	if index is False:
		return False
	edge_for_split=base_wire.Edges[index].copy()
	#edge_for_split.transformGeometry(edge_for_split.Placement.toMatrix())


	#sum up the lengths excluding last edge
	#if index==0:
	#index=index+1

	vertlist=[]
	for j in range(index+1):	#+1#in fact add length until index-1
		if j!=index:
			circumference=circumference+base_wire.Edges[j].Length
		if j==0:
			start_point=start_vertex.Point
			#end_point=start_point

			verts=base_wire.Edges[0].Vertexes
			v_dist=[]
			for k,v in enumerate(verts):
				e_dist=v.Point.distanceToPoint(start_point)
				#print 'e dist: ',e_dist
				if e_dist>1e-3: #Endpoint search
					endp=v.Point
					#print 'Endvertindex: ',k
					vertlist.append(v)
		else:
			vertlist.extend(base_wire.Edges[j].Vertexes)


	hashes=[vert.hashCode() for vert in vertlist]
	endhash=[vert for vert in hashes if hashes.count(vert)<2]
	#print 'End: ',endhash
	idn=hashes.index(endhash[0])
	endp=vertlist[idn].Point
	'''
	for vert in base_wire.Edges[index].Vertexes:
		print 'Equal: ',vert.isEqual(vertlist[idn])
		if vert.isEqual(vertlist[idn]) is False:
			#startp=vert.transformGeometry(vert.Placement.inverse().toMatrix())
			startp=vert.Point
			print 'Startpt: ',startp
	'''

	#end_point=base_wire.Edges[0].valueAt(end_param)

	first_param=base_wire.Edges[index].FirstParameter
	first_point=base_wire.Edges[index].valueAt(first_param)

	last_param=base_wire.Edges[index].LastParameter
	last_point=base_wire.Edges[index].valueAt(last_param)

	first_dist=first_point.distanceToPoint(endp)
	last_dist=last_point.distanceToPoint(endp)
	#print 'FD, LD: ',first_dist,' | ',last_dist
	#find the start and the end of the edge from where to count the circumference
	if first_dist<=tol and last_dist>tol:
		comp_p=last_point
		end_point=first_point
		end_param=first_param
		start_point=last_point
		start_param=last_param

	if first_dist>tol and last_dist<=tol:
		comp_p=first_point
		end_point=last_point
		end_param=last_param
		start_point=first_point
		start_param=first_param

	#Console.PrintMessage("Point distances: " + str(round(first_dist,5))+' | '+str(round(last_dist,5))+ '\n')
	#Console.PrintMessage("Curve parameters: " + str(first_param)+' | '+str(target_param)+' | '+str(last_param) + '\n')

	rest_circum=0
	if target_param>min(start_param,end_param) and target_param<max(start_param,end_param):
		try:
			#Console.PrintMessage("split wire method:  " + '\n')
			split_wire=edge_for_split.split(target_param)
			#print 'Split wire: ',split_wire.Edges
			#Console.PrintMessage("split wire:  " + str(split_wire)+'\n')
			#back=wc.check_point_on_edge_new(split_wire,start_point)
			#rest_circum=split_wire.Edges[back[1]].Length

			#find the edge which has start_point which means has no endhash
			'''
			verthash=[]
			for m,e in enumerate(split_wire.Edges):
				for v in e.Vertexes:
					verthash.append(v.hashCode())
				if verthash.count(endhash)==0:
					idr=m
					break
			'''

			dist=[]

			#'''
			endverts=wc.find_endpoints_h(split_wire.Edges)
			print('Endverts: ',endverts)
			for ev in endverts:
				apart=ev.Point.distanceToPoint(start_point)
				print('Apart: ',apart)
				dist.append(apart)
			mx=dist.index(min(dist))
			for m,e in enumerate(split_wire.Edges):
				if endverts[mx] in e.Vertexes:
					break
			rest_circum=split_wire.Edges[m].Length
			#'''
			'''
			for m,e in enumerate(split_wire.Edges):
				apart=Part.Vertex(start_point).distToShape(e)[0] #mabe placement make problems?
				#print 'Apart: ',apart
				dist.append(apart)

			m=dist.index(min(dist))
			rest_circum=split_wire.Edges[m].Length
			'''

			#print 'Dist: ',dist
			#print 'Rest circum: ',rest_circum
			#Console.PrintMessage("split wire:  " + str(back)+'\n')
		except: #ValueError:
			print('ERROR')
			'''
			if (target_param-min(start_param,end_param))<(max(start_param,end_param)-target_param):
				print 'APPROX SOLUTION'
				approx_solution='START'
				rest_circum=0
			else:
				approx_solution='END'
				rest_circum=edge_for_split.Length
			'''
			#Console.PrintMessage("Approximate solution:  " +str(target_param)+' | ' +str(approx_solution)+ '\n')
			#Console.PrintMessage("Approximate solution:  " +str(target_param-start_param)+' | ' +str(end_param-target_param)+ '\n')
	if math.fabs(start_param-target_param)<1e-3 or approx_solution=='START':
		rest_circum=0
	if math.fabs(end_param-target_param)<1e-3 or approx_solution=='END':
		rest_circum=edge_for_split.Length
		'''
		curve_for_split=edge_for_split.Curve
		if curve_for_split.__class__ is not Part.BSplineCurve:
			curve_for_split=curve_for_split.toBSpline()
		curve_for_split.segment(start_param,target_param)
		rest_circum=curve_for_split.length()
		Part.show(Part.Edge(curve_for_split))
		'''
	circumference=circumference+rest_circum
	print('CIRCUM: ',circumference)

	return circumference #,split_edge_wire


########################################################################################################################################################
########################################################################################################################################################

def wiresort_smart(wire,startedge,startpoint):
	'''
	input wire::Wire,startedge::Edge,startpoint::Vector
	output edgelist::List of edges
	'''
	import wc
	edgelist=[]
	direction_list=[]
	for i in range(len(wire.Edges)):
		if i==0:
			smallest_length=wire.Edges[i].Length
		else:
			if wire.Edges[i].Length<smallest_length:
				smallest_length=wire.Edges[i].Length
	tol=smallest_length/3.0
	Console.PrintMessage("Tolerance:  " + str(round(tol,3))+'\n')
	processingedges=wire.Edges
	p_edge=wc.find_edge_from_vertexes(processingedges,startedge.Vertexes)[0]
	p_point=startpoint
	safeloop=0
	while len(processingedges)>0:
		e_param=p_edge.ParameterRange
		e_start=p_edge.valueAt(e_param[0])#Base Vector
		e_end=p_edge.valueAt(e_param[1])#Base Vector
		Console.PrintMessage("Remaining edges:  " + str(len(processingedges))+' | '+str(p_edge)+' | '+str(p_point.distanceToPoint(e_start))+' | '+str(round(p_edge.Length,3))+'\n')
		if p_point.distanceToPoint(e_start)<tol:
			p_point=e_end
			direction_list.append('FORWARD')
		else:
			p_point=e_start
			direction_list.append('REVERSE')
		edgelist.append(p_edge)
		#Part.show(p_edge)
		result_edge,index=wc.find_edge_from_vertexes(processingedges,p_edge.Vertexes)
		if result_edge!=False:
			processingedges.pop(index)
		for j in range(len(processingedges)):
			for k in range(len(processingedges[j].Vertexes)):
				if j==0 and k==0:
					comp_distance=p_point.distanceToPoint(processingedges[j].Vertexes[k].Point)
					Console.PrintMessage("comparision distance:  " + str(round(p_point.distanceToPoint(processingedges[j].Vertexes[k].Point),3))+'\n')
					next_point=processingedges[j].Vertexes[k]
				else:
					if p_point.distanceToPoint(processingedges[j].Vertexes[k].Point)<comp_distance:
						comp_distance=p_point.distanceToPoint(processingedges[j].Vertexes[k].Point)
						next_point=processingedges[j].Vertexes[k]
						Console.PrintMessage("distance next point:  " + str(round(p_point.distanceToPoint(processingedges[j].Vertexes[k].Point),3))+'\n')
		if len(processingedges)>0:
			p_edge=wc.find_edge_from_vertexes(processingedges,next_point)[0]
			p_point=next_point.Point
		safeloop=safeloop+1
		if safeloop==50:
			raise TypeError('Exit safeloop - Did not find intersection')
			break
	return edgelist,direction_list


########################################################################################################################################################
########################################################################################################################################################


def section_pts4(wire,startedge,startvertex,angular_tol,curvature_tol,mode):
	for i in range(len(wire.Edges)):
		edge_length=wire.Edges[i].Length
		if i==0:
			comp_length=edge_length
		else:
			if edge_length<comp_length:
				comp_length=edge_length

	discretize_interval=comp_length/4

	#reorient the edges if necessary, discretize start at first edge from edge.FirstVertex()
	wireedges=wire.Edges
	newwire=[]
	nextvertex=startvertex
	safeloop=0
	while len(wireedges)>0:
		safeloop=safeloop+1
		if safeloop>len(wire.Edges):
			break
		for i,edge in enumerate(wireedges):
			if len(newwire)==0 and edge.isSame(startedge):
				if edge.firstVertex(True).isSame(nextvertex) is False:
					edge.reverse()
				nextvertex=edge.lastVertex(True)
				newwire.append(edge)
				wireedges.pop(i)
				safeloop=0
				break					
			else:
				if edge.firstVertex(True).isSame(nextvertex) or edge.lastVertex(True).isSame(nextvertex): #found next connecting edge
					if edge.lastVertex(True).isSame(nextvertex):
						edge.reverse()
					nextvertex=edge.lastVertex(True)
					newwire.append(edge)
					wireedges.pop(i)
					safeloop=0
					break

	discwire=Part.Wire(newwire)


	if mode is 'Number':
		nb=int(discwire.Length/angular_tol)+1
		pts=discwire.discretize(Number=nb)

	#pts=wire.discretize(QuasiDeflection=0.0001)

	if mode is 'AngularCurvature':
		pts=discwire.discretize(Angular=angular_tol,Curvature=curvature_tol)#standard method points are a minimum

	max_discretize_dist=3
	nb=int(discwire.Length/max_discretize_dist)+1
	if len(pts)<nb:
		pts=discwire.discretize(Number=nb)		


	if mode is not 'Number' and mode is not 'AngularCurvature':
		return ('No valid mode! Valid modes are ''Number'',''AngularCurvature''')

	
	return pts,pts


########################################################################################################################################################
########################################################################################################################################################


#*************get form points list values from base model*************
# calculation model (t_x_n) only valid for one sided welds
def weld_base_model_values_point_list2(facelist,base_wire,y_direction,point_list):
	'''
	get the vectors of the weld for calculating weld inclination and weld rotation
	input: weld, face, base_wire, y_direction, point_list
	weld is used for determining the correct direction of the medial axis
	face is used to get the normal of surface = vector_list[1]
	return normalized vectors: list of tuples [tangent,normal,tangent_x_normal]
	'''
	vector_list=[]
	for j in range(len(point_list)):
		vector_list_single=[]
		poi=point_list[j]
		tol=1e-2
		ed,index,param=wc.check_point_on_edge_weave(base_wire,poi)

		if y_direction[index]=='FORWARD':	#used for orientate the weld
			tan=ed.tangentAt(param)
		else:
			tan=ed.tangentAt(param).negative()
		for face in facelist:
			if face.isInside(poi,1e-3,True):
				n=face.Surface.parameter(poi)
				normal=face.normalAt(n[0],n[1])
				normal.normalize()
				t_x_n=tan.cross(normal)*0.1		#just to minimize distances to facilitate neareast point search
				val_1=Part.Vertex(poi.add(t_x_n))
				val_2=Part.Vertex(poi.add(t_x_n.negative()))
				#Console.PrintMessage('T_x_N: j: '+str(j)+' | Val_1: ' +str(round(weld.distToShape(val_1)[0],3))+' | Val_2: '+str(round(weld.distToShape(val_2)[0],3))+ '\n')
				if face.distToShape(val_1)[0]<face.distToShape(val_2)[0]:	#not reliable IMPROVE
					t_x_n=t_x_n.negative()
				else:
					pass
				t_x_n.normalize()
				vector_list_single.append(tan)
				vector_list_single.append(normal)
				vector_list_single.append(t_x_n)
				vector_list.append(vector_list_single)
				break
	return vector_list

########################################################################################################################################################
########################################################################################################################################################

def Basecurve(facecomp_orig):
	#print ('after face placment: ',face.Placement)
	res_wires=[]
	for i,orig_wire in enumerate(facecomp_orig.Wires):
		wire=orig_wire.copy()
		#print ('Wire placment: ',i,' | ',wire.Edges[0].Placement)
		if len(wire.Edges)==1 and wire.isClosed() is True:
			#print ('Wire spliting: ')	
			param_span=wire.Edges[0].ParameterRange[1]-wire.Edges[0].ParameterRange[0]
			half_param=wire.Edges[0].ParameterRange[0]+param_span*1.0/3.0
			w0=wire.Edges[0].split(half_param)
			lengths=[w0.Edges[0].Length,w0.Edges[1].Length]
			index=lengths.index(min(lengths))
			new_wire=[w0.Edges[index]]
			#Part.show(new_wire[0])

			index=lengths.index(max(lengths))
			param_span=w0.Edges[index].ParameterRange[1]-w0.Edges[index].ParameterRange[0]
			half_param=w0.Edges[index].ParameterRange[0]+param_span*1.0/2.0
			w1=w0.Edges[index].split(half_param)
			new_wire=new_wire+w1.Edges
			wire=Part.Wire(new_wire)

		wire=wire.transformGeometry(orig_wire.Placement.toMatrix())
		wire.Placement=Base.Placement()	
		#Part.show(wire)
		#print ('Wire placment: ',wire.Edges[0].Placement)
		res_wires.append(wire)
	return res_wires

########################################################################################################################################################
########################################################################################################################################################


def show_vecs(pts,vec_list,baselength,ptnnb):
	'''
	show the 3-tuple vector
	return None
	'''
	lcs=[]
	for i in ptnnb:

		base=pts[i]
		v_0=base+vec_list[i][0]*baselength
		v_1=base+vec_list[i][1]*baselength*2
		if vec_list[i][2] is not None:
			v_2=base+vec_list[i][2]*baselength*4
			l2=Part.makeLine(base,v_2)
		else:
			l2=None
		l0=Part.makeLine(base,v_0)
		l1=Part.makeLine(base,v_1)

		LKS=Part.makeCompound([l0,l1,l2])
		lcs.append(LKS)

	origin=Part.makeCompound(lcs)
	return origin

########################################################################################################################################################
########################################################################################################################################################

#picking the startedge from a closed contour Node outside edge
#pick the root face

def slicerCSV(pts,vec_list,seqdata,fileabs):
	#writing the very base data into csv file

	fields=['Ptid','x','y','z','ax','ay','az','bx','by','bz','cx','cy','cz','Sequence','Wpsname','Pos','Passorder']
	#fields=['x','y','z','ax','ay','az','bx','by','bz','cx','cy','cz']
	ps=[[pts[i].x,pts[i].y,pts[i].z] for i in range(len(pts))]
	idx=0
	vs_a=[[vec_list[i][idx].x,vec_list[i][idx].y,vec_list[i][idx].z] for i in range(len(vec_list))]
	idx=1
	vs_b=[[vec_list[i][idx].x,vec_list[i][idx].y,vec_list[i][idx].z] for i in range(len(vec_list))]
	idx=2
	vs_c=[[vec_list[i][idx].x,vec_list[i][idx].y,vec_list[i][idx].z] for i in range(len(vec_list))]

	rows=[[i]+ps[i][:]+vs_a[i][:]+vs_b[i][:]+vs_c[i][:]+seqdata[i] for i in range(len(pts))]

	#write directly to file
	with open(fileabs, 'w') as csvfile:
		# creating a csv writer object
		csvwriter = csv.writer(csvfile, dialect='excel-tab',lineterminator='\n') #is different for python3
		csvwriter.writerow(fields) # writing the fields
		csvwriter.writerows(rows) # writing the data rows


########################################################################################################################################################
########################################################################################################################################################

def RemoveDuplicatePts(i_pt_vecs,tolerance):
	'''
	remove duplicate pts in list
	input list of vectors
	return cleaned list of vectors
	previous algo:
		for exm_pt in cleaned_i_pt_vecs:
			#exm_pt=cleaned_i_pt_vecs[j]
			dist=cmp_pt.distanceToPoint(exm_pt)
			#print dist
			if dist<tolerance:
				add_flag=False
				break
	'''
	'''
	cleaned_i_pt_vecs=[]
	for cmp_pt in i_pt_vecs:
		add_flag=True
		dist=[cmp_pt.distanceToPoint(exm_pt) for exm_pt in cleaned_i_pt_vecs]
		if len(dist)>0 and min(dist)<tolerance:
			add_flag=False
		else:

		if add_flag is True:
			cleaned_i_pt_vecs.append(cmp_pt)
	return cleaned_i_pt_vecs
	'''

	cleaned_i_pt_vecs=[]
	for cmp_pt in i_pt_vecs:
		dist=[cmp_pt.distanceToPoint(exm_pt) for exm_pt in cleaned_i_pt_vecs]
		if len(dist)>0 and min(dist)<tolerance:
			pass
		else:
			cleaned_i_pt_vecs.append(cmp_pt)
	return cleaned_i_pt_vecs


###################################################################
###################################################################